using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class SiteMaster : System.Web.UI.MasterPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Page.User.IsInRole("Administrator") && Page.User.Identity.IsAuthenticated)
        {
            WebPartMenu.Visible = true;
        }
        else
        {
            WebPartMenu.Visible = false;
        }

        if (!Page.IsPostBack)
        {
            MenuItem rootMenuItem = new MenuItem("Administration") ;
            rootMenuItem.Selectable = false;
            foreach (WebPartDisplayMode displayMode in WebPartManager1.DisplayModes)
            {
                rootMenuItem.ChildItems.Add(new MenuItem(displayMode.Name));
            }
            WebPartMenu.Items.Add(rootMenuItem);

            WebPartMenu.Items.Add(new MenuItem("Logout"));
        }
    }

    protected void WebPartMenu_MenuItemClick(object sender, MenuEventArgs e)
    {
        if (e.Item.Text == "Logout")
        {
            FormsAuthentication.SignOut();
            WebPartMenu.Visible = false;
            WebPartManager1.DisplayMode = WebPartManager.BrowseDisplayMode;
        }

        foreach (WebPartDisplayMode newMode in WebPartManager1.DisplayModes)
        {
            if (newMode.Name.Equals(e.Item.Text))
            {
                WebPartManager1.DisplayMode = newMode ;
                break ;
            }
        }
    }
}
