using System;
using System.Collections.Generic;
using System.Text;

using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

using Winsmarts.OPMLEditor;

namespace Winsmarts.RSSRender
{
    public class UIWebPart : WebPart, IRssFeedContract
    {
        private string rssUrl;

        [WebBrowsable(true)]
        [Personalizable(PersonalizationScope.Shared)]
        public string RSSUrl
        {
            get { return rssUrl; }
            set 
            {
                rssUrl = value;
            }
        }

        protected override void RenderContents(System.Web.UI.HtmlTextWriter writer)
        {
            RssFeed feed = new RssFeed(rssUrl);
            HyperLink newLink = new HyperLink();
            foreach (RssItem singleRssItem in feed)
            {
                newLink.Text = singleRssItem.Title;
                newLink.NavigateUrl = singleRssItem.Href;
                newLink.Target = "rssSite";
                newLink.RenderControl(writer);
                writer.WriteBreak();
            }
        }

        //Communication code begins.

        #region IRssFeedContract Members

        string IRssFeedContract.RSSUrl
        {
            get { return rssUrl; }
            set { rssUrl = value ; }
        }

        #endregion

        [ConnectionProvider("Rss service Provider")]
        public IRssFeedContract GetRssCommunicationPoint()
        {
            return this as IRssFeedContract;
        }
    }
}
